var d3 = require('d3');
var p4 = require('p4');
var sectionADiv = document.querySelector("div.sectionA");
var serverInfoDiv = document.querySelector("div.u-6-8");
var sectionBDiv = document.querySelector("div.sectionB");

function clear() {
    serverInfoDiv.text = "";
    sectionADiv.text = "Welcome, please click a button.";
    sectionBDiv.text = "";
}

function info() {
    p4.run("-p localhost:1666 info", function(err, stdout) {
        var info = stdout.split("\n");
        serverInfoDiv.innerHTML = "<br>";
        serverInfoDiv.innerHTML += info[11] + "<br>";
        serverInfoDiv.innerHTML += info[13] + "<br>";
    });
}

function users() {
    p4.run("-p localhost:1666 users", function(err, data) {
        var users = data.split("\n");
        for (var j=0; j<users.length-1; j++) {
            sectionBDiv.innerHTML += users[j] + "<br>";
        }
    });
}

function protect() {
    p4.run("-p localhost:1666 protect -o", function(err, data) {
        var protect = data.split("\n");
        sectionADiv.innerHTML = "";
        for (var j=0; j<protect.length-1; j++) {
            sectionADiv.innerHTML += protect[j] + "<br>";
        }
    });
}

function values() {
    p4.run("-p localhost:1666 help commandments", function(err, data) {
        var values = data.split("\n");
        var content = "";
        sectionADiv.innerHTML = "";
        //skip index 0 since that's just a new line
        for (var j=1; j<values.length-1; j++) {
            content += values[j] + "<br>";
            console.log(content);
        }
        sectionADiv.innerHTML = content;
    });
}

function configure() {
    p4.run("-p localhost:1666 configure show", function(err, data) {
        var values = data.split("\n");
        sectionADiv.innerHTML = "";
        for (var j=0; j<values.length-1; j++) {
            sectionADiv.innerHTML += values[j] + "<br>";
        }
    });
}

function counters() {
    p4.run("-p localhost:1666 counters", function(err, data){
        var counters = data.split("\n");
        var counterValues = new Array();
        var counterNames = new Array();

        for (var i=0; i<counters.length-1; i++) {
            result = counters[i].split("=");
            counterNames[i] =  result[0];
            counterValues[i] = result[1];
        }

      var x = d3.scale.linear()
          .domain([0, d3.max(counterValues)])
          .range([0, 420]);

      d3.select(".chart")
          .selectAll("div")
          .data(counterValues)
          .enter().append("div")
          .on("mouseover", function(d, i) { serverInfoDiv.innerHTML = "<br>"
               + counterNames[i] + " = " + d; })
          .on("mouseout", function() { serverInfoDiv.innerHTML = ""})
          .style("width", function (d) { return x(d) + "px"; })
          .text(function(d, i){ return  d; })
    });
}
